#include <stdio.h>

#include <stdlib.h>

#include <math.h>

#include "common1.h"

#include "common2.h"

#include "common3.h"





/*

 void write_sp(a,sd)

 struct mat ***a;

 double **sd;

{ FILE *fp;

  int i,j,k,n;

  double zdf;



  for(n=0;n<LR;n++)

    for(i=0;i<N_DEM;i++)

      for(k=0;k<N_TIME;k++)

        shdpri[n][i][k]=0.;



 

  for(k=0;k<N_BLK;k++) {

    zdf=dis_f[n_tm[k]]*prob_k[k];

    for(i=0;i<N_DEM;i++) {

      j=jc[6][0][i][k];

      for(n=0;n<LR;n++)

        shdpri[n][i][n_tm[k]]=-vec_vec(sd[n],a[n][j])/zdf;

    }

  }



  fp=fopen("shadow.dat","w");

  for(i=0;i<N_DEM;i++) {

    for(n=0;n<LR;n++) {

      fprintf(fp,"Region%2d:",n+1);

      for(k=0;k<N_TIME;k++)

        fprintf(fp," %7.2f",shdpri[n][i][k]);

      fprintf(fp,"\n");

    }

    fprintf(fp,"\n");

  }



  fprintf(fp,"\n");

  fclose(fp);

}

*/





  int read_result()

{ FILE *fp;

  double v;

  int i,j,k,n,pindex;



  fp=fopen("result.out","r");



  fscanf(fp," %4d\n",&i);

  if(i!=JC) {

    printf(" Inconsistent input data files...\n");

    printf(" Please check the file 'control.dat'.\n");

    exit(0);

  }



  for(n=0;n<LR;n++)

    for(i=0;i<JC;i++) { x[n][i]=0.; g[n][i]=0.; }



  for(n=0;n<LR;n++){

    for(i=0;i<JC;i++) {

      fscanf(fp,"%lf %d\n",&v,&j);

      if(j==1) x[n][i]=v;

      else     g[n][i]=v;

    }

  }



  fscanf(fp," %4d\n",&i);

  if(i!=IR) {

    printf(" Inconsistent input data files...\n");

    printf(" Please check the file 'control.dat'.\n");

    exit(0);

  }

  for(n=0;n<LR;n++)

    for(i=0;i<IR;i++) {

      fscanf(fp,"%lf\n",&sd[n][i]);

  }



  fscanf(fp," %4d\n",&k);

  if(k!=KE) {

    printf(" Inconsistent input data files...\n");

    printf(" Please check the file 'control.dat'.\n");

    exit(0);

  }

  for(k=0;k<KE;k++) fscanf(fp,"%lf\n",&p[k]);



  fclose(fp);

  return(1);

}

  

  void account_r(n,txm,xm)

  int n;

  double ***txm,*xm;

{ int i,j,k,l,i0,j0,ky0,k1,k2,idim;

  int iep[5]={1,2,3,7,8};

  int ich[19]={0,1,2,3,4,5,6,7,8,9,10,11,12,12,12,13,14,15,16};

  double elesh[3]={1.,1./2.,1./3.};

  double u0,u,v,w,dsum,dyr,dshare[3],wel;

  double **trf,**tre,*elef,*tdl,trc[2],trd[2],u1,u2;

  double thred;



  elef=(double *) malloc(8*N_EPLNT);

  tdl=(double *) malloc(8*7);

  trf=m_darr2(IINTER,LR);

  tre=m_darr2(IINTER,LR);



/******************************************

            preprocess

*******************************************/



  for(k=0;k<N_TIME;k++) {

    inv0[n][k]=ivs0[n][k]*gdp0[n][k];

    if(k==0) {

      kap0[n][k]=(dis_i3[n][k]*mepm[n][2]+dis_i1[n][k]*ivs_2000[n])*gdp_2000[n]

          +dis_i2[n][k]*inv0[n][k];

    }

    else {

      kap0[n][k]=dis_i3[n][k]*kap0[n][k-1]

       +inv0[n][k]*dis_i2[n][k]+inv0[n][k-1]*dis_i1[n][k];

    }

  }

  for(i=0;i<N_DEM;i++)

    prelas[n][i]=1./elast[n][i];

  klelas[n]=1.-1./mepm[n][1];

  enelas[n]=1.-1./mepm[n][3];



  cem_2000[n]=0.;

  for(i=0;i<N_FOS;i++)

    cem_2000[n]+=co2cef[i+1]*(prtrad[n][i]+currpr[n][i]);



  dsum=0.;

  for(i=0;i<3;i++) dsum+=dulfel[n][i];

  for(i=0;i<3;i++) dshare[i]=dulfel[n][i]/dsum;



  thred=24.;



/******************************************

              Accounting

******************************************/

  for(k=0;k<N_BLK;k++) {

    ky0=n_tm[k];

    k1=inc_mat[0][k];

    k2=inc_mat[1][k];



    if(k1>=0)

      dyr=n_yr[ky0]-n_yr[n_tm[k1]];

    else

      dyr=n_yr[ky0]-start_yr;



    for(i=0;i<N_EPLNT;i++)

      elef[i]=elcoef[i][ky0]*etcon;

    for(i=1;i<4;i++)

      elef[i]*=relaef[i-1][n][ky0];



    for(i=0;i<7;i++)

      tdl[i]=1./(1.-tdloss[n][i][ky0]);



    wel=chcoef[JP_W_ELEC][0][ky0]/etcon;

    plcost[7][0]=nclurt[n][ky0];





  /* transportation loss */



    for(i=0;i<LR;i++) {

      if(i!=n) {

        u1=-trocea[n][i];

        u2=-trland[n][i]; 

        for(j=0;j<3;j++) {

          if(j<2) {

            v=pow(1.-trnlos[2*j][ky0],u1)*pow(1.-trnlos[2*j+1][ky0],u2);

            u=0.;

	  }

          else {

            v=pow(co2ene[2][0][ky0],u2);

            u=co2ene[2][1][ky0]*u2;

            if(fabs(u2)>0.01) {

              v/=co2ene[1][0][ky0];

              u-=co2ene[1][1][ky0];

	    }

	  }

          if(fabs(u1)>0.01) {

            v/=chcoef[JP_H2_LIQ+j][0][ky0];

            u-=chcoef[JP_H2_LIQ+j][1][ky0];

	  }

          trf[j][i]=v;

          tre[j][i]=v*u/3.;

	}

      }

      else {

        for(j=0;j<3;j++) {

          trf[j][i]=-1.;

          tre[j][i]=0.;

	}

      }

    }



    u1=-trnco2[n][0];

    u2=-trnco2[n][1];



    trc[0]=pow(co2ene[2][0][ky0],u1)/co2ene[1][0][ky0]/co2ene[0][0][ky0];

    trd[0]=trc[0]*(co2ene[2][1][ky0]*u1-co2ene[1][1][ky0]-co2ene[0][1][ky0])/3.;



    v=pow(co2ene[2][0][ky0],u2);

    u=co2ene[2][1][ky0]*u2;

    if(fabs(u2)>0.01) {

      v/=co2ene[1][0][ky0];

      u-=co2ene[1][1][ky0];

    }

    if(fabs(trnco2[n][2])>0.01) {

      v/=chcoef[JP_C2_LIQ][0][ky0];

      u-=chcoef[JP_C2_LIQ][1][ky0];

    }

    trc[1]=v;

    trd[1]=v*u/3.;



/******************************************

            Hydrogen Balance

******************************************/

    j0=ts_ene[0];

    idim=0;



/* Trade */

    v=0.;

    for(i=0;i<LR;i++)

      v-=trf[0][i]*xm[jc[0][0][i][k]];

    txm[j0][idim++][k]=v;



/* Production */

    txm[j0][idim++][k]=xm[jc[7][0][4][k]];

    v=xm[jc[5][6][1][k]];

    for(i=0;i<3;i++)

      v+=xm[jc[7][2][i][k]];

    txm[j0][idim++][k]=wel*v;

    

/* Consumption */

    v=0.;

    for(i=0;i<3;i++)

      v+=xm[jc[5][0][i][k]];

    txm[j0][idim++][k]=-v;

    txm[j0][idim++][k]=-xm[jc[7][0][5][k]];

    txm[j0][idim++][k]=-xm[jc[5][0][3][k]];



/* Distribution Loss */

    v=-xm[jc[7][0][5][k]];

    for(i=0;i<4;i++)

      v-=xm[jc[5][0][i][k]];

    txm[j0][idim++][k]=v*(tdl[0]-1.);



/******************************************

          Natural Gas Balance

*******************************************/

    j0=ts_ene[1];

    idim=0;



/* Trade */

    v=0.;

    for(i=0;i<LR;i++)

      v-=trf[1][i]*xm[jc[0][1][i][k]];

    txm[j0][idim++][k]=v;

/* Production */

    v=0.;

    for(i=0;i<N_EGRADE;i++)

      v+=xm[jc[2][0][i][k]];

    txm[j0][idim++][k]=v;

    txm[j0][idim++][k]=xm[jc[7][0][0][k]];

    txm[j0][idim++][k]=chcoef[JP_COAL_L][1][ky0]*xm[jc[5][3][7][k]];



/* Consumption */

    v=0.;

    for(i=0;i<3;i++)

      v+=xm[jc[5][1][i][k]];

    txm[j0][idim++][k]=-v;

    txm[j0][idim++][k]=-xm[jc[5][1][3][k]];

    txm[j0][idim++][k]=-xm[jc[5][1][4][k]];

    txm[j0][idim++][k]=-demand[n][0][ky0]*shfdsk[n][0];



/* Distribution Loss */

    v=-demand[n][0][ky0]*shfdsk[n][0];

    for(i=0;i<5;i++)

      v-=xm[jc[5][1][i][k]];

    txm[j0][idim++][k]=v*(tdl[1]-1.);

/******************************************

               Oil Balance

*******************************************/

    j0=ts_ene[2];

    idim=0;



/* Trade */

    txm[j0][idim++][k]=xm[jc[1][0][1][k]]-xm[jc[1][0][0][k]]

		              +xm[jc[1][5][1][k]]-xm[jc[1][5][0][k]];



/* Production */

    v=0.;

    for(i=0;i<N_EGRADE;i++)

      v+=xm[jc[2][1][i][k]];

    txm[j0][idim++][k]=v;

    txm[j0][idim++][k]=co2sub[0]*(xm[jc[2][4][0][k]]+xm[jc[2][4][1][k]]);

    txm[j0][idim++][k]=chcoef[JP_COAL_L][0][ky0]*xm[jc[5][3][7][k]];

    txm[j0][idim++][k]=chcoef[JP_BIOM_L][0][ky0]*xm[jc[5][4][4][k]];



/* Consumption */

    v=0.;

    for(i=0;i<3;i++)

      v+=xm[jc[5][2][i][k]]+xm[jc[5][7][i][k]];

    txm[j0][idim++][k]=-v;

    for(i=3;i<6;i++)

      txm[j0][idim++][k]=-xm[jc[5][2][i][k]]-xm[jc[5][7][i][k]];

    txm[j0][idim++][k]=-demand[n][1][ky0]*shfdsk[n][1];



/* Refinery Loss */

    v=-demand[n][1][ky0]*shfdsk[n][1];

    for(i=0;i<6;i++)

      if(i!=3)

        v-=xm[jc[5][2][i][k]]+xm[jc[5][7][i][k]];

    v*=(1./chcoef[JP_OIL_DI][0][ky0]-1.);

    txm[j0][idim++][k]=v+(xm[jc[5][2][3][k]]+xm[jc[5][7][3][k]])

      *(1.-1/chcoef[JP_OIL_GA][0][ky0]/chcoef[JP_OIL_DI][0][ky0]);



/* Distribution Loss */

    v=-demand[n][1][ky0]*shfdsk[n][1];

    for(i=0;i<6;i++)

      if(i!=3)

        v-=xm[jc[5][2][i][k]]+xm[jc[5][7][i][k]];

    v-=(xm[jc[5][2][3][k]]+xm[jc[5][7][3][k]])/chcoef[JP_OIL_GA][0][ky0];

    txm[j0][idim++][k]=v*(tdl[2]-1.)/chcoef[JP_OIL_DI][0][ky0];



/******************************************

             Sulphur Balance

*******************************************/

    j0=ts_ene[8];

    idim=0;



 /* Gross */

    v=0.;

    for(i=0;i<9;i++)

      v+=xm[jc[5][3][i][k]]*sulcef[0];

    for(i=0;i<7;i++)

      v+=xm[jc[5][2][i][k]]*sulcef[1];

    txm[j0][idim++][k]=v;

 /* Desulphur by coal cleaning */

	txm[j0][idim++][k]=-xm[jc[7][4][0][k]];

 /* Desulphur by Sorbent injection on coal fired power */

	txm[j0][idim++][k]=-xm[jc[7][4][1][k]];

 /* Desulphur by W.L.S. on coal fired power */

	txm[j0][idim++][k]=-xm[jc[7][4][2][k]];

 /* Desulphur by Wellman-Lord on coal fired power */

	txm[j0][idim++][k]=-xm[jc[7][4][3][k]];

 /* Desulphur on IGCC, coal liquefaction and the gasification */

    v=0.;

    for(i=3;i<8;i++)

      v+=0.99*sulcef[0]*xm[jc[5][3][i][k]];

	txm[j0][idim++][k]=-v;

 /* Desulphur on final demands of coal */

    v=0.;

    for(i=0;i<3;i++) v+=xm[jc[7][5][i][k]];

    txm[j0][idim++][k]=-v;

 /* Desulphur by Sorbent injection on oil fired power */

    txm[j0][idim++][k]=-xm[jc[7][6][0][k]];

 /* Desulphur by W.L.S. on oil fired power */

    txm[j0][idim++][k]=-xm[jc[7][6][1][k]];

 /* Desulphur by Wellman-Lord on oil fired power */

    txm[j0][idim++][k]=-xm[jc[7][6][2][k]];

 /* Desulphur on Refinery */

    txm[j0][idim++][k]=-xm[jc[7][6][3][k]];

 /* Desulphur on final demands of oil */

    v=0.;

    for(i=0;i<2;i++) v+=xm[jc[7][7][i][k]];

    txm[j0][idim++][k]=-v;

 /* Net Emission */

    txm[j0][idim++][k]=xm[jc[6][4][0][k]];



/******************************************

              Coal Balance

*******************************************/

    j0=ts_ene[3];

    idim=0;



/* Trade */

    txm[j0][idim++][k]=xm[jc[1][1][1][k]]-xm[jc[1][1][0][k]];



/* Production */

    v=0.;

    for(i=0;i<N_EGRADE;i++)

      v+=xm[jc[2][2][i][k]];

    txm[j0][idim++][k]=v;



/* Consumption */

    v=0.;

    for(i=0;i<3;i++)

      v+=xm[jc[5][3][i][k]];

    txm[j0][idim++][k]=-v;

    v=0.;

    for(i=3;i<6;i++)

      v+=xm[jc[5][3][i][k]];

    txm[j0][idim++][k]=-v;

    for(i=6;i<9;i++)

      txm[j0][idim++][k]=-xm[jc[5][3][i][k]];

    txm[j0][idim++][k]=-demand[n][2][ky0]*shfdsk[n][2];



/* Distribution Loss */

    v=-demand[n][2][ky0]*shfdsk[n][2];

    for(i=0;i<9;i++)

        v-=xm[jc[5][3][i][k]];

    txm[j0][idim++][k]=v*(tdl[3]-1.);



/******************************************

          Biomass Balance

******************************************/

    j0=ts_ene[4];

    idim=0;

/* Energy Crops Production */

	v=0.;

	for(i=0;i<5;i++) v+=xm[jc[3][3][i][k]];

    txm[j0][idim++][k]=v;



/* Modern Fuel Wood Production */

    v=0.;

    for(i=0;i<5;i++) v+=xm[jc[3][3][i+5][k]];

    txm[j0][idim++][k]=v;



/* Wood Residues */

    txm[j0][idim++][k]=xm[jc[3][3][10][k]];



/* Sawmill Residues */

    txm[j0][idim++][k]=xm[jc[3][3][11][k]];



/* Timber Scraps*/

    v=0.;

    for(i=0;i<3;i++) v+=xm[jc[3][3][i+12][k]];

    txm[j0][idim++][k]=v;



/* Cereal Harvest */

    txm[j0][idim++][k]=xm[jc[3][3][15][k]];

/* Sugarcase Harvest */

	txm[j0][idim++][k]=xm[jc[3][3][16][k]];

/* Bagasse */

	txm[j0][idim++][k]=xm[jc[3][3][17][k]];

/* Paper Scraps */

	txm[j0][idim++][k]=xm[jc[3][3][18][k]];

/* Black Liquor */

	txm[j0][idim++][k]=xm[jc[3][3][19][k]];

/* Kitchen Wastes */

	txm[j0][idim++][k]=xm[jc[3][3][20][k]];

/* Animal Wastes (Dry) */

	txm[j0][idim++][k]=xm[jc[3][3][21][k]];

/* Animal Wastes (Wet) */

	txm[j0][idim++][k]=xm[jc[3][3][22][k]];

/* Human Feces */

	txm[j0][idim++][k]=xm[jc[3][3][23][k]];



/* Electricity Generation */

    v=0.;

    for(i=0;i<3;i++) v+=xm[jc[5][4][i][k]];

    txm[j0][idim++][k]=-v;

/* Gasification */

    txm[j0][idim++][k]=-xm[jc[5][4][3][k]]-xm[jc[5][4][11][k]];

/* Liquefaction */

    txm[j0][idim++][k]=-xm[jc[5][4][4][k]]-xm[jc[5][4][6][k]]

		   -xm[jc[5][4][7][k]]-xm[jc[5][4][8][k]];

/* Final Demand */

    txm[j0][idim++][k]=-xm[jc[5][4][5][k]]-xm[jc[5][4][10][k]];

/* Distribution Loss */

    v=0.;

    for(i=0;i<18;i++) v-=txm[j0][i][k];

    txm[j0][18][k]=v;



/******************************************

          Methanol Balance

*******************************************/

    j0=ts_ene[5];

    idim=0;



/* Trade */

    txm[j0][idim++][k]=xm[jc[1][2][1][k]]-xm[jc[1][2][0][k]];



/* Production */

    txm[j0][idim++][k]=xm[jc[7][0][1][k]];

    txm[j0][idim++][k]=xm[jc[7][0][8][k]];



/* Consumption */

    v=0.;

    for(i=0;i<3;i++)

      v+=xm[jc[5][5][i][k]];

      txm[j0][idim++][k]=-v;

    for(i=3;i<6;i++)

      txm[j0][idim++][k]=-xm[jc[5][5][i][k]];



/* Distribution Loss */

    v=0.;

    for(i=0;i<6;i++)

        v-=xm[jc[5][5][i][k]];

    txm[j0][idim++][k]=v*(tdl[5]-1.);



/******************************************

          Wind Power Balance

*******************************************/

    j0=ts_ene[6];

    idim=0;

/* Production */

    txm[j0][idim++][k]=xm[jc[3][1][0][k]];

/* Consumption */

    for(i=0;i<2;i++)

      txm[j0][idim++][k]=-xm[jc[5][6][i][k]];



/******************************************

          Oil Product Balance

*******************************************/

    j0=ts_ene[7];



    v=xm[jc[5][2][5][k]]+xm[jc[5][7][5][k]];

    for(i=0;i<3;i++)

      v+=xm[jc[5][2][i][k]]+xm[jc[5][7][i][k]];

    txm[j0][0][k]=100.*v/

      (v+xm[jc[5][2][3][k]]+xm[jc[5][2][4][k]]

      +xm[jc[5][7][3][k]]+xm[jc[5][7][4][k]]

	  +shfdsk[n][1]*demand[n][1][ky0]);

/******************************************

     Biomass Constraints

*******************************************/

	/* Major Biomass */

    j0=ts_bio[0]; 

    idim=0;

    for(i=5;i<18;i++) txm[j0][idim++][k]=xm[jc[3][3][i][k]];

	txm[j0][idim++][k]=xm[jc[5][4][9][k]];

    for(i=3;i<6;i++) txm[j0][idim++][k]=-tdl[4]*xm[jc[5][4][i][k]];

	txm[j0][idim++][k]=-xm[jc[5][4][13][k]];



	/*Energy Crops Balances */

    j0=ts_bio[1];

    idim=0;

    for(i=0;i<5;i++) txm[j0][idim++][k]=xm[jc[3][3][i][k]];

    for(i=6;i<9;i++) txm[j0][idim++][k]=-tdl[4]*xm[jc[5][4][i][k]];

 	txm[j0][idim++][k]=-xm[jc[5][4][9][k]];



	/* Paper Scraps */

    j0=ts_bio[2];

    idim=0;

    txm[j0][idim++][k]=xm[jc[3][3][18][k]];

    txm[j0][idim++][k]=-tdl[4]*xm[jc[5][4][10][k]];

    txm[j0][idim++][k]=-tdl[4]*xm[jc[5][4][11][k]];

    txm[j0][idim++][k]=-xm[jc[5][4][12][k]];



/* Biomass Balances for Electric Fuel */

    j0=ts_bio[3];

    idim=0;

    txm[j0][idim++][k]=xm[jc[3][3][19][k]];

    txm[j0][idim++][k]=xm[jc[3][3][20][k]];

    txm[j0][idim++][k]=xm[jc[3][3][21][k]];

    txm[j0][idim++][k]=xm[jc[5][4][12][k]];

    txm[j0][idim++][k]=xm[jc[5][4][13][k]];

    v=0.;

    for(i=0;i<3;i++) v-=tdl[4]*xm[jc[5][4][i][k]];

    txm[j0][idim++][k]=v;



/* Arable Land area constraints */

    j0=ts_bio[4];

    idim=0;

    txm[j0][idim++][k]=xm[jc[3][3][24][k]];

    txm[j0][idim++][k]=xm[jc[3][3][25][k]];

    txm[j0][idim++][k]=landarea[n][ky0];



/* Energy crops */

    j0=ts_bio[5];

    idim=0;

    if(bio_productivity[n][0][ky0]!=0.) {

      for(i=0;i<5;i++)

        txm[j0][idim++][k]=xm[jc[3][3][i][k]]/bio_productivity[n][0][ky0];

      v=0.;

      for(i=0;i<5;i++) v+=xm[jc[3][3][i][k]]/bio_productivity[n][0][ky0];

    }

    else{

      for(i=0;i<5;i++) txm[j0][idim++][k]=0.;

      v=0.;

    }

    txm[j0][idim++][k]=v;

    txm[j0][idim++][k]=xm[jc[3][3][24][k]];



/* Modern fuel woods */

    j0=ts_bio[6];

    idim=0; 

    if(bio_productivity[n][1][ky0]!=0.) {

      for(i=0;i<5;i++)

        txm[j0][idim++][k]=xm[jc[3][3][i+5][k]]/bio_productivity[n][1][ky0];

      v=0.;

      for(i=0;i<5;i++) v+=xm[jc[3][3][i+5][k]]/bio_productivity[n][1][ky0];

    }

    else {

      for(i=0;i<5;i++) txm[j0][idim++][k]=0.;

      v=0.;

    }

    txm[j0][idim++][k]=v;

    txm[j0][idim++][k]=xm[jc[3][3][25][k]];



/******************************************

           H2 Balance in IES

*******************************************/

    j0=ts_ies[0];

    idim=0;



    txm[j0][idim++][k]=chcoef[JP_SHIFT][0][ky0]*xm[jc[7][0][3][k]];

    txm[j0][idim++][k]=xm[jc[7][0][5][k]];

    txm[j0][idim++][k]=chcoef[JP_NGAS_C][0][ky0]*xm[jc[5][1][3][k]];

    txm[j0][idim++][k]=chcoef[JP_COAL_G][0][ky0]*xm[jc[5][3][6][k]];

    txm[j0][idim++][k]=chcoef[JP_BIOM_G][0][ky0]

		                    *(xm[jc[5][4][3][k]]+xm[jc[5][4][11][k]]);

    txm[j0][idim++][k]=-chcoef[JP_CH4_SY][0][ky0]*xm[jc[7][0][0][k]];

    txm[j0][idim++][k]=-chcoef[JP_MEOH_S][0][ky0]*xm[jc[7][0][1][k]];

    txm[j0][idim++][k]=-chcoef[JP_MEOH_D][0][ky0]*xm[jc[7][0][8][k]];

    txm[j0][idim++][k]=-xm[jc[7][0][2][k]];

    txm[j0][idim++][k]=-xm[jc[7][0][4][k]];



/******************************************

       Carbon Monoxide Balance in IES

*******************************************/

    j0=ts_ies[1];

    idim=0;



    txm[j0][idim++][k]=chcoef[JP_SHIFT][0][ky0]*xm[jc[7][0][2][k]];

    txm[j0][idim++][k]=chcoef[JP_NGAS_C][1][ky0]*xm[jc[5][1][3][k]];

    txm[j0][idim++][k]=chcoef[JP_COAL_G][1][ky0]*xm[jc[5][3][6][k]];

    txm[j0][idim++][k]=chcoef[JP_BIOM_G][1][ky0]

		                    *(xm[jc[5][4][3][k]]+xm[jc[5][4][11][k]]);

    txm[j0][idim++][k]=-chcoef[JP_CH4_SY][1][ky0]*xm[jc[7][0][0][k]];

    txm[j0][idim++][k]=-chcoef[JP_MEOH_S][1][ky0]*xm[jc[7][0][1][k]];

    txm[j0][idim++][k]=-xm[jc[7][0][3][k]];



/******************************************

           CO2 Balance in IES

*******************************************/

    j0=ts_ies[2];

    idim=0;



    u=co2cef[6];

    txm[j0][idim++][k]=u*xm[jc[7][0][3][k]];

    txm[j0][idim++][k]=xm[jc[7][0][7][k]];

    v=co2cef[1]-chcoef[JP_NGAS_C][1][ky0]*u;

    txm[j0][idim++][k]=v*xm[jc[5][1][3][k]];

    v=co2cef[3]-chcoef[JP_COAL_G][1][ky0]*u;

    txm[j0][idim++][k]=v*xm[jc[5][3][6][k]];

    v=co2cef[4]-chcoef[JP_BIOM_G][1][ky0]*u;

    txm[j0][idim++][k]=v*(xm[jc[5][4][3][k]]+xm[jc[5][4][11][k]]);

    txm[j0][idim++][k]=-chcoef[JP_SHIFT][0][ky0]*u*xm[jc[7][0][2][k]];

    txm[j0][idim++][k]=-xm[jc[7][0][6][k]];

    txm[j0][idim++][k]=-chcoef[JP_MEOH_D][1][ky0]*xm[jc[7][0][8][k]];



/******************************************

        Recoverd CO2 Balance in Total

*******************************************/

    j0=ts_rco2;

    idim=0;



/* Trade */

    v=0.;

    for(i=0;i<LR;i++)

      v-=trf[2][i]*xm[jc[0][2][i][k]];

    txm[j0][idim++][k]=v;



/* Recovery */

    txm[j0][idim++][k]=chcoef[JP_CO2R_P][0][ky0]*xm[jc[7][0][6][k]];

    for(i=3;i<6;i++)

      txm[j0][idim++][k]=co2cef[3]*chcoef[JP_CO2R_P][0][ky0]*xm[jc[5][3][i][k]];

    for(i=0;i<3;i++)

      txm[j0][idim++][k]=chcoef[JP_CO2R_C][0][ky0]*xm[jc[7][1][i][k]];



/* Recycle */

    txm[j0][idim++][k]=-xm[jc[7][0][7][k]];



/* Disposal */

    txm[j0][idim++][k]=-trc[0]*(xm[jc[2][4][0][k]]+xm[jc[2][4][1][k]]);

    txm[j0][idim++][k]=-trc[0]*xm[jc[2][4][2][k]];

    v=0.;

    for(i=0;i<5;i++) v-=trc[0]*xm[jc[2][4][3+i][k]];

    txm[j0][idim++][k]=v;

    txm[j0][idim++][k]=-trc[1]*xm[jc[2][4][8][k]];



/******************************************

       Energy Balance in Demand side

*******************************************/



    for(i=0;i<N_DEM-1;i++)

      cdemak[n][i][k]=demand[n][i][ky0]*(1.-shfdsk[n][i]);

    cdemak[n][N_DEM-1][k]=demand[n][N_DEM-1][ky0];

    for(i=0;i<N_DEM;i++)  cdemak[n][i][k]*=(1.-sh_new_t[n][ky0]);

    for(i=0;i<N_DEM;i++)

      rdemak[n][i][k]=enepot[n][ky0]*cdemak[n][i][k];



/* Gaseous Fuel */

    j0=td_ndemd[0];

    idim=0;

    txm[j0][idim++][k]=xm[jc[5][0][3][k]];

    txm[j0][idim++][k]=xm[jc[5][1][4][k]];

    txm[j0][idim++][k]=chcoef[JP_BIOM_GA][0][ky0]*xm[jc[3][3][22][k]];

    txm[j0][idim++][k]=chcoef[JP_BIOM_GA][0][ky0]*xm[jc[3][3][23][k]];

    txm[j0][idim++][k]=demand[n][0][ky0]*(1.-shfdsk[n][0])*sh_new_t[n][ky0];

    txm[j0][idim++][k]=cdemak[n][0][k]-xm[jc[6][0][0][k]]-rdemak[n][0][k];

    txm[j0][idim++][k]=-demand[n][0][ky0]*(1.-shfdsk[n][0]);



/* Liquid */

    v=cdemak[n][1][k]-xm[jc[6][0][1][k]]-rdemak[n][1][k];

    u=demand[n][1][ky0]*(1.-shfdsk[n][1]);

 /* Gasoline */

    j0=td_ndemd[1];

    idim=0;

    txm[j0][idim++][k]=xm[jc[5][2][3][k]]+xm[jc[5][7][3][k]];

	txm[j0][idim++][k]=chcoef[JP_BIOM_LF][0][ky0]*xm[jc[5][4][6][k]];

    txm[j0][idim++][k]=chcoef[JP_MEOH_U][0][ky0]*xm[jc[5][5][3][k]];

    txm[j0][idim++][k]=oilsha[n][0][ky0]*u*sh_new_t[n][ky0];

    txm[j0][idim++][k]=oilsha[n][0][ky0]*v;

    txm[j0][idim++][k]=-oilsha[n][0][ky0]*u;



 /* Light Liquid Fuel */

    j0=td_ndemd[2];

    idim=0;

    txm[j0][idim++][k]=xm[jc[5][2][4][k]]+xm[jc[5][7][4][k]];

	txm[j0][idim++][k]=chcoef[JP_BIOM_LF][0][ky0]*xm[jc[5][4][7][k]];

    txm[j0][idim++][k]=xm[jc[5][5][4][k]];

    txm[j0][idim++][k]=oilsha[n][2][ky0]*u*sh_new_t[n][ky0];

    txm[j0][idim++][k]=oilsha[n][2][ky0]*v;

    txm[j0][idim++][k]=-oilsha[n][2][ky0]*u;



/* Heavy Liquid Fuel */

    j0=td_ndemd[3];

    idim=0;

    txm[j0][idim++][k]=xm[jc[5][2][5][k]]+xm[jc[5][7][5][k]];

	txm[j0][idim++][k]=chcoef[JP_BIOM_LF][0][ky0]*xm[jc[5][4][8][k]];

    txm[j0][idim++][k]=xm[jc[5][5][5][k]];

    txm[j0][idim++][k]=oilsha[n][1][ky0]*u*sh_new_t[n][ky0];;

    txm[j0][idim++][k]=oilsha[n][1][ky0]*v;

    txm[j0][idim++][k]=-oilsha[n][1][ky0]*u;



/* Solid Fuel */

    j0=td_ndemd[4];

    idim=0;

    txm[j0][idim++][k]=xm[jc[5][3][8][k]];

    txm[j0][idim++][k]=xm[jc[5][4][5][k]];

    txm[j0][idim++][k]=xm[jc[5][4][10][k]];

    txm[j0][idim++][k]=demand[n][2][ky0]*(1.-shfdsk[n][2])*sh_new_t[n][ky0];

    txm[j0][idim++][k]=cdemak[n][2][k]-xm[jc[6][0][2][k]]-rdemak[n][2][k];

    txm[j0][idim++][k]=-demand[n][2][ky0]*(1.-shfdsk[n][2]);



/*********************************************

              Electric Sector 

*********************************************/



/* Elec. Generation */

    for(l=0;l<3;l++) {

      j0=td_edemd[l];

      idim=0;



   /* Thermal power */

      for(i=0;i<7;i++) {

        v=0.;

        for(j=l;j<3;j++)

          v+=elef[i]*elesh[j]*xm[jc[9][i][j][k]];

		if(i==2)

	      for(j=l;j<3;j++)

            v+=elef[i]*elesh[j]*xm[jc[9][8][j][k]];

        txm[j0][idim++][k]=v;

      }



   /* Nuclear */

      txm[j0][idim++][k]=xm[jc[2][3][0][k]]/3.;



   /* Elec. storage */

      i0=jc[7][3][0][k];

      v=elcoef[8][ky0];

      if(l==0)

        u=-xm[i0]-xm[i0+1]+v*(xm[i0+2]+xm[i0+4]);

      if(l==1)

        u=-xm[i0+2]-xm[i0+3]+v*(xm[i0+1]+xm[i0+5]);

      if(l==2)

        u=-xm[i0+4]-xm[i0+5]+v*(xm[i0]+xm[i0+3]);

      txm[j0][idim++][k]=u;



   /* Hydro&Geothermal */

      txm[j0][idim++][k]=dshare[l]*xm[jc[3][0][0][k]];



   /* Wind */

      txm[j0][idim++][k]=xm[jc[5][6][0][k]]/3.;



   /* Photovoltaics */

      if(parele[n][2]!=0.0&&l==0)

        txm[j0][idim++][k]=xm[jc[3][2][0][k]];

      else if(parele[n][2]==0.0&&l==1)

        txm[j0][idim++][k]=xm[jc[3][2][0][k]];

      else

        txm[j0][idim++][k]=0.;



   /* total idim=12*/

      v=0.;

      for(i=0;i<idim;i++)

        v+=txm[j0][i][k];

      txm[j0][idim++][k]=v;



/* Elec. Consumption */



   /* For Transportation */

      v=0.;

      for(j=0;j<IINTER;j++)

        for(i=0;i<LR;i++) 

          v+=tre[j][i]*xm[jc[0][j][i][k]];

      txm[j0][idim++][k]=-v;



   /* Elec. for CO2 Recovery */

      v=0.;

      for(j=l;j<3;j++)

        v+=chcoef[JP_CO2R_C][1][ky0]*elesh[j]*xm[jc[7][1][j][k]];

      txm[j0][idim++][k]=-v;

      txm[j0][idim++][k]=-1./3.*chcoef[JP_CO2R_P][1][ky0]*xm[jc[7][0][6][k]];



   /* Elec. for CO2 Disposal */

      v=trd[1]*xm[jc[2][4][N_DCO2-1][k]];

      for(i=0;i<N_DCO2-1;i++)

        v+=trd[0]*xm[jc[2][4][i][k]];

      txm[j0][idim++][k]=v;



   /* Elec. for Water Electrolysis */

      txm[j0][idim++][k]=-xm[jc[7][2][l][k]];



   /* Elec. for Chemical Plants */

      v=-1./3.;

      txm[j0][idim++][k]=v*chcoef[JP_NGAS_C][2][ky0]*xm[jc[5][1][3][k]];

      txm[j0][idim++][k]=v*chcoef[JP_COAL_G][2][ky0]*xm[jc[5][3][6][k]];

      txm[j0][idim++][k]=v*chcoef[JP_BIOM_G][2][ky0]

		                       *(xm[jc[5][4][3][k]]+xm[jc[5][4][11][k]]);

      txm[j0][idim++][k]=v*chcoef[JP_MEOH_S][2][ky0]*xm[jc[7][0][1][k]];

      txm[j0][idim++][k]=v*chcoef[JP_MEOH_D][2][ky0]*xm[jc[7][0][8][k]];

  

      

   /* Distribution Loss */

      v=chcoef[JP_CO2R_P][1][ky0]*xm[jc[7][0][6][k]];

      v+=chcoef[JP_NGAS_C][2][ky0]*xm[jc[5][1][3][k]];

      v+=chcoef[JP_COAL_G][2][ky0]*xm[jc[5][3][6][k]];

      v+=chcoef[JP_BIOM_G][2][ky0]*(xm[jc[5][4][3][k]]+xm[jc[5][4][11][k]]);

      v+=chcoef[JP_MEOH_S][2][ky0]*xm[jc[7][0][1][k]];

      v/=3.;

      v+=xm[jc[7][2][l][k]];

      v+=dshare[l]*(xm[jc[6][0][3][k]]+rdemak[n][3][k]);

      txm[j0][idim++][k]=-v*(tdl[6]-1.);

     

   /* Innovatives */

      txm[j0][idim++][k]=dshare[l]*demand[n][3][ky0]*sh_new_t[n][ky0];

   /* Conservation */

      txm[j0][idim++][k]=dshare[l]

                  *(cdemak[n][3][k]-xm[jc[6][0][3][k]]-rdemak[n][3][k]);

   /* Elec. demand */

      txm[j0][idim++][k]=-dshare[l]*demand[n][3][ky0];

   }



    j0=td_edemd[3];

    for(i=0;i<idim;i++) {

      v=0.;

      for(l=0;l<3;l++)

        v+=txm[td_edemd[l]][i][k];

      txm[j0][i][k]=v;

    }



/************************************************

      Electricity Peak Supply Capability

*************************************************/

    j0=td_edemd[4];

    idim=0;



   /* Elec. from Thermal, Nuclear and Storage Power */

    for(i=0;i<9;i++)

      txm[j0][idim++][k]=plcost[i][0]*xm[jc[8][0][i][k]];



    if(ky0<=5) {

      if(k1>=0) 

        for(i=0;i<9;i++)

          txm[j0][i][k]+=plcost[i][0]*xm[jc[8][0][i][k1]];

      if(k2>=0)

        for(i=0;i<9;i++)

          txm[j0][i][k]+=plcost[i][0]*xm[jc[8][0][i][k2]];

    }



    if(ky0==0) 

      for(i=0;i<5;i++)

       txm[j0][iep[i]][k]+=plcost[iep[i]][0]*(cexist[n][i][0]+cexist[n][i][1]);

    if(ky0==1)

      for(i=0;i<5;i++)

        txm[j0][iep[i]][k]+=plcost[iep[i]][0]*cexist[n][i][0];



   /* Elec. from Renewable Energy */

    txm[j0][idim++][k]=dshare[0]*3.*rpyt*xm[jc[3][0][0][k]];

    txm[j0][idim++][k]=rpyt*xm[jc[5][6][0][k]];

    if(parele[n][2]!=0.)

      txm[j0][idim++][k]=3.*rpyt*parele[n][2]*xm[jc[3][2][0][k]];

    else

      txm[j0][idim++][k]=0.;



   /* Total */

    v=0.;

    for(i=0;i<idim;i++)

      v+=txm[j0][i][k];

    txm[j0][idim++][k]=v;



    u=3.*rpyt*(1.+parele[n][0]);



   /* For transportation */

    v=0.;

    for(j=0;j<IINTER;j++)

      for(i=0;i<LR;i++)

        v+=tre[j][i]*xm[jc[0][j][i][k]];

    txm[j0][idim++][k]=-u*v;



   /* For CO2 Disposal */

    v=trd[1]*xm[jc[2][4][N_DCO2-1][k]];

    for(i=0;i<N_DCO2-1;i++) 

      v+=trd[0]*xm[jc[2][4][i][k]];

    txm[j0][idim++][k]=u*v;



   /* For Chemical Plants */

    v=-rpyt*tdl[6];

    txm[j0][idim++][k]=v*chcoef[JP_CO2R_P][1][ky0]*xm[jc[7][0][6][k]];

    txm[j0][idim++][k]=v*chcoef[JP_NGAS_C][2][ky0]*xm[jc[5][1][3][k]];

    txm[j0][idim++][k]=v*chcoef[JP_COAL_G][2][ky0]*xm[jc[5][3][6][k]];

    txm[j0][idim++][k]=v*chcoef[JP_BIOM_G][2][ky0]

		         *(xm[jc[5][4][3][k]]+xm[jc[5][4][11][k]]);

    txm[j0][idim++][k]=v*chcoef[JP_MEOH_S][2][ky0]*xm[jc[7][0][1][k]];

    txm[j0][idim++][k]=v*chcoef[JP_MEOH_D][2][ky0]*xm[jc[7][0][8][k]];



   /* Demand */

    v=u/dsum*tdl[6];

    txm[j0][idim++][k]=-v*(xm[jc[6][0][3][k]]+rdemak[n][3][k]);



/*******************************************

    Regional Average Generation Efficiency 

*******************************************/

  /* Loss in CO2 Chemical Recovery */    

    v=0.;

    for(l=0;l<3;l++)

      for(j=l;j<3;j++)

        v-=chcoef[JP_CO2R_C][1][ky0]*elesh[j]*xm[jc[7][1][j][k]];

    u=0.;

    for(i=0;i<7;i++)

      for(j=0;j<3;j++) {

        v+=elef[i]*xm[jc[9][i][j][k]];

        u+=xm[jc[9][i][j][k]];

    }

    for(j=0;j<3;j++) {

      v+=elef[2]*xm[jc[9][8][j][k]];

      u+=xm[jc[9][8][j][k]];

    }

    txm[td_edemd[5]][0][k]=v/u/etcon*100.;





/*******************************************

    Capacities of Electric Power Plants

*******************************************/

/* Thermal Power Plants */

   for(i=0;i<7;i++) {

     j0=tp_elec[i];

     idim=0;

     txm[j0][0][k]=xm[jc[8][0][i][k]];

     v=elef[i]*rpyt/plcost[i][0];

     u=0.;

     for(j=0;j<3;j++)

       u-=3.*v*elesh[j]*xm[jc[9][i][j][k]];

	 if(i==2)

       for(j=0;j<3;j++)

         u-=3.*v*elesh[j]*xm[jc[9][8][j][k]];

     txm[j0][3][k]=u;

   }



/* Nuclear Power */

   j0=tp_elec[7];

   txm[j0][0][k]=xm[jc[8][0][7][k]];

   v=rpyt/nclurt[n][ky0];

   txm[j0][3][k]=-v*xm[jc[2][3][0][k]];



/* Electricity Storage */

   j0=tp_elec[8];

   txm[j0][0][k]=xm[jc[8][0][8][k]];

   v=rpyt/parele[n][1];

   u=0.;

   for(i=0;i<6;i++)

     u+=v*xm[jc[7][3][i][k]];

   txm[j0][3][k]=-u;



   j0=tp_elec[0];

   if(ky0==0) 

     for(i=0;i<5;i++) {

       txm[j0+iep[i]][1][k]=cexist[n][i][0];

       txm[j0+iep[i]][2][k]=cexist[n][i][1];

     }

   if(ky0==1)

     for(i=0;i<5;i++)

       txm[j0+iep[i]][2][k]=cexist[n][i][0];



   if(ky0<=4) {

     if(k1>=0)

       for(i=0;i<9;i++)

         txm[tp_elec[i]][1][k]=xm[jc[8][0][i][k1]];

     if(k2>=0)

       for(i=0;i<9;i++)

         txm[tp_elec[i]][2][k]=xm[jc[8][0][i][k2]];

   }





/******************************************

        Capacities of Chemical Plants

*******************************************/



    v=-1./plcost[9][0]/chcoef[JP_OIL_DI][0][ky0];

    u=0.;

    for(i=0;i<6;i++)

      if(i!=3)

        u+=v*(xm[jc[5][2][i][k]]+xm[jc[5][7][i][k]]);

    u+=v/chcoef[JP_OIL_GA][0][ky0]*chcoef[JP_OIL_DI][0][ky0]

		*(xm[jc[5][2][3][k]]+xm[jc[5][7][3][k]]);

    txm[tp_chem[0]][3][k]=u;



    txm[tp_chem[1]][3][k]=-1./plcost[10][0]*xm[jc[5][2][3][k]]

		                  -1./plcost[10][0]*xm[jc[5][7][3][k]];



    txm[tp_chem[2]][3][k]=-1./plcost[11][0]*xm[jc[5][1][3][k]];

    txm[tp_chem[3]][3][k]=-1./plcost[12][0]*xm[jc[5][3][6][k]];

    txm[tp_chem[4]][3][k]=-1./plcost[13][0]*xm[jc[5][3][7][k]];

    txm[tp_chem[5]][3][k]=-1./plcost[14][0]*(xm[jc[5][4][3][k]]+xm[jc[5][4][11][k]]);

    txm[tp_chem[6]][3][k]=-1./plcost[15][0]*xm[jc[5][4][4][k]];

    txm[tp_chem[7]][3][k]=-1./plcost[16][0]*xm[jc[7][0][0][k]];

    txm[tp_chem[8]][3][k]=-1./plcost[17][0]*xm[jc[7][0][1][k]];

    txm[tp_chem[9]][3][k]=-1./plcost[18][0]*xm[jc[7][0][8][k]];



    txm[tp_chem[10]][3][k]=-1./plcost[19][0]*(xm[jc[5][1][3][k]]

       +xm[jc[5][3][6][k]]+xm[jc[5][4][3][k]]+xm[jc[5][4][11][k]]+xm[jc[7][0][5][k]]);



    txm[tp_chem[11]][3][k]=-1./plcost[20][0]*xm[jc[5][5][3][k]];



    v=wel/plcost[21][0];

    for(i=0;i<3;i++) 

      txm[tp_chem[12+i]][3][k]=-v*(3.*xm[jc[7][2][i][k]]+xm[jc[5][6][1][k]]);



    txm[tp_chem[15]][3][k]=-1./plcost[22][0]*(3.*xm[jc[7][1][0][k]]

                         +1.5*xm[jc[7][1][1][k]]+xm[jc[7][1][2][k]]);



    txm[tp_chem[16]][3][k]=-1./plcost[23][0]*xm[jc[7][0][6][k]];



    txm[tp_chem[17]][3][k]=-1./plcost[27][0]

              *(xm[jc[3][3][22][k]]+xm[jc[3][3][23][k]]);

    txm[tp_chem[18]][3][k]=-1./plcost[28][0]

              *(xm[jc[5][4][6][k]]+xm[jc[5][4][7][k]]+xm[jc[5][4][8][k]]);



    j0=tp_chem[0];

    for(i=0;i<19;i++) {

      txm[j0+i][0][k]=xm[jc[8][1][ich[i]][k]];

      if(ky0<=4) {

        if(k1>=0) 

          txm[j0+i][1][k]=xm[jc[8][1][ich[i]][k1]];

        if(k2>=0) 

          txm[j0+i][2][k]=xm[jc[8][1][ich[i]][k2]];

      }

    }



    if(ky0==0) {

      txm[j0][1][k]=cexist[n][5][0];

      txm[j0][2][k]=cexist[n][5][1];

      txm[j0+1][1][k]=cexist[n][6][0];

      txm[j0+1][2][k]=cexist[n][6][1];

    }

    if(ky0==1) {

      txm[j0][2][k]=cexist[n][5][0];

      txm[j0+1][2][k]=cexist[n][6][0];

    }



/******************************************

         CO2 Emissions Constraint

*******************************************/

    j0=ta_eco2;

    idim=0;



 /* Gross */

    v=0.;

    for(i=0;i<LR;i++)

      if(i!=n) v-=co2cef[1]*xm[jc[0][1][i][k]];

      else     v+=co2cef[1]*xm[jc[0][1][i][k]];

    v+=co2cef[2]*(xm[jc[1][0][1][k]]-xm[jc[1][0][0][k]]

		         +xm[jc[1][5][1][k]]-xm[jc[1][5][0][k]]);

    v+=co2cef[3]*(xm[jc[1][1][1][k]]-xm[jc[1][1][0][k]]);

    v+=co2cef[5]*(xm[jc[1][2][1][k]]-xm[jc[1][2][0][k]]);

    for(i=0;i<N_FOS;i++)

      for(j=0;j<N_EGRADE;j++)

        v+=co2cef[i+1]*rco2cef[i][j]*xm[jc[2][i][j][k]];

    v+=co2cef[2]*co2sub[0]*(xm[jc[2][4][0][k]]+xm[jc[2][4][1][k]]);

    txm[j0][idim++][k]=v;



 /* Trade */ 

    v=0.;

    for(i=0;i<LR;i++) 

      if(i!=n)  v-=xm[jc[0][2][i][k]];

      else      v+=xm[jc[0][2][i][k]];

    txm[j0][idim++][k]=v;



 /* CO2 Disposal */

    txm[j0][idim++][k]=-(xm[jc[2][4][0][k]]+xm[jc[2][4][1][k]]);

    txm[j0][idim++][k]=-xm[jc[2][4][2][k]];

    v=0.;

    for(i=0;i<5;i++) v-=xm[jc[2][4][3+i][k]];

    txm[j0][idim++][k]=v;

    txm[j0][idim++][k]=-xm[jc[2][4][8][k]];



 /* Reforestation */

    v=0.;

    for(i=0;i<N_REFO;i++) {

      v+=xm[jc[2][5][i][k]];

      if(ky0>0 && dyr<thred) v+=xm[jc[2][5][i][k1]];

      if(ky0>1 && n_yr[ky0]-n_yr[ky0-1]<thred) v+=xm[jc[2][5][i][k2]];

    }

    txm[j0][idim++][k]=-v;



 /* Net Emissions */

    v=0.;

    for(i=0;i<idim;i++)

      v+=txm[j0][i][k];

    txm[j0][idim++][k]=v; 



 /* Emissions Right */



    txm[j0][idim++][k]=xm[jc[1][3][1][k]]-xm[jc[1][3][0][k]]

                      +xm[jc[1][4][1][k]]-xm[jc[1][4][0][k]];



 /* Reforestation by Grade*/

    for(i=0;i<N_REFO;i++) {

      v=xm[jc[2][5][i][k]];

      if(ky0>0 && dyr<thred) v+=xm[jc[2][5][i][k1]];

      if(ky0>1 && n_yr[ky0]-n_yr[ky0-1]<thred) v+=xm[jc[2][5][i][k2]];

      txm[j0][idim++][k]=v;

    }





/******************************************

     Cumulative Fossil Fuel Production

*******************************************/

    for(i=0;i<N_FOS;i++) {

      u0=currpr[n][i];

      for(j=0;j<N_EGRADE;j++){

        if(k1==-1) {

          if(u0>0.) u=u0;

          else u=0.;

          u0-=egrade[n][i][j]*2000./(n_yr[n_tm[k]]-start_yr);

          if(u0>0.) u-=u0;

          v=start_yr;

          w=0.;

	}

        else {

          u=xm[jc[2][i][j][k1]];

          v=n_yr[n_tm[k1]];

          w=txm[ts_exha[i]][j][k1];

	}

        txm[ts_exha[i]][j][k]

          =(xm[jc[2][i][j][k]]+u)*(n_yr[n_tm[k]]-v)*0.5+w;

      }

      u=0.;

      for(j=0;j<N_EGRADE;j++) u+=txm[ts_exha[i]][j][k];

      txm[ts_exha[i]][N_EGRADE][k]=u/1000.;

  }



/******************************************

  Cumulative CO2 Disposal and Net Emissions

*******************************************/

    j0=ts_dco2;

    for(i=0;i<N_DCO2;i++) {

      if(ky0==0) {

        u=0.;

        w=0.;

      }

      else {

        u=xm[jc[2][4][i][k1]];

        w=txm[j0][i][k1];

      }

      txm[j0][i][k]=(xm[jc[2][4][i][k]]+u)*dyr*0.5/1000.+w;

    }



    for(i=0;i<N_REFO;i++) {

      if(ky0==0) {

        u=0.;

        w=0.;

      }

      else {

        u=txm[ta_eco2][9+i][k1];

        w=txm[j0][i+N_DCO2][k1];

      }

      txm[j0][i+N_DCO2][k]=(txm[ta_eco2][9+i][k]+u)*dyr*0.5/1000.+w;

    }



    if(ky0==0) {

      u=cem_2000[n];

      w=0.;

    }

    else {

      u=txm[ta_eco2][7][k1];

      w=txm[j0][N_DCO2+N_REFO][k1];

    }

    txm[j0][N_DCO2+N_REFO][k]=(txm[ta_eco2][7][k]+u)*dyr*0.5/1000.+w;



/******************************************

        Primary Energy Production

*******************************************/



    agg[n][k]=1./txm[td_edemd[5]][0][k]/etcon*100.;



    j0=ts_pene;

    idim=0;

    for(i=0;i<N_FOS;i++) {

      v=0.;

      for(j=0;j<N_EGRADE;j++)

        v+=xm[jc[2][i][j][k]];

      txm[j0][idim++][k]=v;

    }

    for(i=0;i<N_REN-1;i++)

      txm[j0][idim++][k]=xm[jc[3][i][0][k]]*agg[n][k];

	v=0.;

	for(i=0;i<24;i++) v+=xm[jc[3][3][i][k]];

    txm[j0][idim++][k]=v;

    txm[j0][idim++][k]=xm[jc[2][3][0][k]]*agg[n][k];

    v=demand[n][N_DEM-1][k]*agg[n][k];

    for(i=0;i<N_DEM-1;i++)

      v+=demand[n][i][k]*(1.-shfdsk[n][i]);

    txm[j0][idim++][k]=v*sh_new_t[n][k];



/******************************************

        Primary Energy Supply

*******************************************/



    j0=ts_psup;

    idim=0;

    for(i=0;i<N_FOS;i++) {

      v=txm[ts_ene[i+1]][0][k];

      for(j=0;j<N_EGRADE;j++)

        v+=xm[jc[2][i][j][k]];

      txm[j0][idim++][k]=v;

    }

    txm[j0][idim++][k]=txm[ts_ene[5]][0][k];



    for(i=0;i<N_REN-1;i++)

      txm[j0][idim++][k]=xm[jc[3][i][0][k]]*agg[n][k];

    v=0.;

    for(i=0;i<24;i++) v+=xm[jc[3][3][i][k]];

    txm[j0][idim++][k]=v;

    txm[j0][idim++][k]=xm[jc[2][3][0][k]]*agg[n][k];

    v=demand[n][N_DEM-1][k]*agg[n][k];

    for(i=0;i<N_DEM-1;i++) v+=demand[n][i][k]*(1.-shfdsk[n][i]);

    txm[j0][idim++][k]=v*sh_new_t[n][k];



/******************************************

        Final Energy Consumption

*******************************************/

    j0=ts_sene;

    idim=0;

    txm[j0][idim++][k]=xm[jc[5][0][3][k]];

    txm[j0][idim++][k]=xm[jc[5][1][4][k]]+demand[n][0][ky0]*shfdsk[n][0];

    txm[j0][idim++][k]=xm[jc[5][2][3][k]]+xm[jc[5][2][4][k]]+xm[jc[5][2][5][k]]

              +xm[jc[5][7][3][k]]+xm[jc[5][7][4][k]]+xm[jc[5][7][5][k]]

              +demand[n][1][ky0]*shfdsk[n][1];

    txm[j0][idim++][k]=chcoef[JP_MEOH_U][0][ky0]*xm[jc[5][5][3][k]]

                      +xm[jc[5][5][4][k]]+xm[jc[5][5][5][k]];

    txm[j0][idim++][k]=chcoef[JP_BIOM_LF][0][ky0]

		*(xm[jc[5][4][6][k]]+xm[jc[5][4][7][k]]+xm[jc[5][4][8][k]]);

    txm[j0][idim++][k]=xm[jc[5][3][8][k]]+demand[n][2][ky0]*shfdsk[n][2];

    txm[j0][idim++][k]=xm[jc[5][4][5][k]]

	+chcoef[JP_BIOM_GA][0][ky0]*(xm[jc[3][3][22][k]]+xm[jc[3][3][23][k]]);

    txm[j0][idim++][k]=(xm[jc[6][0][3][k]]+rdemak[n][3][k])/etcon;

    v=demand[n][N_DEM-1][k]/etcon;

    for(i=0;i<N_DEM-1;i++)

      v+=demand[n][i][k]*(1.-shfdsk[n][i]);

    txm[j0][idim++][k]=v*sh_new_t[n][k];



/********************************************************

                    Macro Economic 

*********************************************************/

    rkap[n][k]=kap_low[n][ky0]*kap0[n][ky0]/1000.;

    kapk[n][k]=kap0[n][ky0]/1000.;



  }

  

  for(k=0;k<N_BLK;k++)

    for(i=0;i<N_FOS;i++)

      for(j=0;j<N_EGRADE;j++)

        if(egrade[n][i][j]!=0.)

          txm[ts_exha[i]][j][k]/=(egrade[n][i][j]*10.);

        else

          txm[ts_exha[i]][j][k]=100.;



  free(tre);

  free(trf);  



}



  void account_w()

{ int i,j,k,n;

  double v,u;

  double **emi;



  emi=m_darr2(N_SCE,N_TIME+1);



  for(i=0;i<JT;i++)

    for(j=0;j<30;j++)

      for(k=0;k<N_BLK;k++) {

        v=0.;

        for(n=0;n<LR;n++)

          v+=tx[n][i][j][k];

        tx[LR][i][j][k]=v;

      }





  for(i=0;i<JT;i++)

    for(j=0;j<30;j++)

      for(k=0;k<N_BLK;k++) {

        v=0.;

        for(n=0;n<4;n++)

          v+=tx[n][i][j][k];

        tx[LR+1][i][j][k]=v;

      }

  for(i=0;i<JT;i++)

    for(j=0;j<30;j++)

      for(k=0;k<N_BLK;k++) {

        v=0.;

        for(n=4;n<LR;n++)

          v+=tx[n][i][j][k];

        tx[LR+2][i][j][k]=v;

      }





  for(i=0;i<JT;i++)

    for(j=0;j<30;j++)

      for(k=0;k<N_BLK;k++) {

        v=tx[9][i][j][k];

        for(n=0;n<4;n++)

          v+=tx[n][i][j][k];

        tx[LR+3][i][j][k]=v;

      }



  for(i=0;i<JT;i++)

    for(j=0;j<30;j++)

      for(k=0;k<N_BLK;k++) {

        v=0.;

        for(n=4;n<9;n++)

          v+=tx[n][i][j][k];

        tx[LR+4][i][j][k]=v;

      }



  for(i=0;i<JT;i++)

    for(j=0;j<30;j++)

      for(k=0;k<N_BLK;k++) {

        v=0.;

        for(n=4;n<6;n++) v+=tx[n][i][j][k];

        tx[LR+5][i][j][k]=v;

      }





  for(k=0;k<N_BLK;k++)

    for(i=0;i<N_FOS;i++)

      for(j=0;j<N_EGRADE;j++) {

        v=0.;

        u=0.;

        for(n=0;n<LR;n++) {

          v+=tx[n][ts_exha[i]][j][k]*egrade[n][i][j];

          u+=egrade[n][i][j];

	}

        if(u!=0.)

          tx[LR][ts_exha[i]][j][k]=v/u;

        else

          tx[LR][ts_exha[i]][j][k]=100.;

      }



 /* World Energy System Costs */

  for(i=0;i<LR;i++) {

    for(k=0;k<N_BLK;k++)

      tx[LR][tc_cost[15]][i][k]=tx[i][tc_cost[13]][12][k];

    for(k=0;k<N_SCE;k++)

      tx[LR][tc_cost[16]][i][k]=tx[i][tc_cost[14]][12][k];

  }



 /* World Trades */

  for(k=0;k<N_BLK;k++) 

    for(i=0;i<LR;i++) {

      tx[LR][ts_trade[0]][i][k]=tx[i][ts_ene[0]][0][k];

      tx[LR][ts_trade[1]][i][k]=tx[i][ts_ene[1]][0][k];

      tx[LR][ts_trade[2]][i][k]=tx[i][ts_ene[2]][0][k];

      tx[LR][ts_trade[3]][i][k]=tx[i][ts_ene[3]][0][k];

      tx[LR][ts_trade[4]][i][k]=tx[i][ts_ene[5]][0][k];

      tx[LR][ts_trade[5]][i][k]=tx[i][ta_eco2][1][k];

      tx[LR][ts_trade[6]][i][k]=x[i][jc[1][3][1][k]]-x[i][jc[1][3][0][k]]

                               +x[i][jc[1][4][1][k]]-x[i][jc[1][4][0][k]];

    }



 /* World Energy Production */

  for(k=0;k<N_BLK;k++) 

    for(i=0;i<LR;i++) 

      for(j=0;j<N_FOS+N_REN+1;j++)

        tx[LR][ts_wep[j]][i][k]=tx[i][ts_pene][j][k];



  for(k=0;k<N_BLK;k++) 

    for(i=0;i<LR;i++) {

        tx[LR][ts_wco[0]][i][k]=x[i][jc[2][4][0][k]]+x[i][jc[2][4][1][k]];

        tx[LR][ts_wco[1]][i][k]=x[i][jc[2][4][2][k]];

        v=0.;

        for(j=0;j<5;j++) v+=x[i][jc[2][4][3+j][k]];

        tx[LR][ts_wco[2]][i][k]=v;

        tx[LR][ts_wco[3]][i][k]=x[i][jc[2][4][8][k]];

        tx[LR][ts_wco[4]][i][k]=x[i][jc[6][4][0][k]];

      }







 /* Climate Model */

  for(k=0;k<N_BLK;k++) 

    for(i=0;i<N_SCE;i++) 

      if(n_sc[i][k]==1){

        emi[i][n_tm[k]+1]=tx[LR][ta_eco2][7][k]/1000;

        for(n=0;n<LR;n++){

          rtmp_risex[i][n][n_tm[k]]=

             (x[n][jc[6][2][0][k]]-x[n][jc[6][2][1][k]])*1.e-5;

	}

      }



  for(i=0;i<N_SCE;i++) emi[i][0]=co2emi[i][0];

  climate(1,emi,tsoxemi);



  free(emi);

}







  void account_c(n,txm,xm,sdm)

  int n;

  double ***txm,*xm,*sdm;

{ int i,j,j0,k,ky0,k1,k2;

  double u,v,zdf;

  int iep[5]={1,2,3,7,8};

  double tc[11][2],**mc,dyr,ctax,sum_ec,stax;





  mc=m_darr2(N_PLNT,N_BLK);



  for(i=0;i<N_DEM;i++) 

    for(k=0;k<N_TMP;k++)

      dispri[n][i][k]=enepri[n][i]-shdpri[n][i][0];



  /* Unit Construction Costs */

  for(k=0;k<N_BLK;k++) {

    ky0=n_tm[k];

    dyr=n_yr[ky0]-start_yr;

    for(i=0;i<9;i++) {

      v=pow(1.-plcost[i][3],dyr);

      u=plcost[i][4];

      if(u==0.)      v*=rlcost[0][n][ky0];

      else if(u==1.) v*=rlcost[1][n][ky0];

      else if(u==2.) v*=rlcost[2][n][ky0];

      else if(u==3.) v*=rlcost[3][n][ky0];

      else if(u==4.) v*=rlcost[4][n][ky0];

      else if(u==5.) v*=rlcost[5][n][ky0];

      else if(u==6.) v*=rlcost[6][n][ky0];

      else if(u==7.) v*=rlcost[7][n][ky0];

      else if(u==8.) v*=rlcost[8][n][ky0];

      else if(u==9.) v*=rlcost[9][n][ky0];

      else {

        printf(" Please Check 'plcost[i][4]'.\n");

        exit(0);

      }

      mc[i][k]=plcost[i][1]*plcost[i][2]*v;

    }

    for(i=0;i<15;i++) {

      v=pow(1.-plcost[i+9][3],dyr);

      u=plcost[i+9][4];

      if(u==0.)      v*=rlcost[0][n][ky0];

      else if(u==1.) v*=rlcost[1][n][ky0];

      else if(u==2.) v*=rlcost[2][n][ky0];

      else if(u==3.) v*=rlcost[3][n][ky0];

      else if(u==4.) v*=rlcost[4][n][ky0];

      else if(u==5.) v*=rlcost[5][n][ky0];

      else if(u==6.) v*=rlcost[6][n][ky0];

      else if(u==7.) v*=rlcost[7][n][ky0];

      else if(u==8.) v*=rlcost[8][n][ky0];

      else if(u==9.) v*=rlcost[9][n][ky0];

      else {

        printf(" Please Check 'plcost[i][4]'.\n");

        exit(0);

      }

      mc[i+9][k]=plcost[i+9][1]*plcost[i+9][2]*v/365.;

    }

    for(i=18;i<20;i++) {

      v=pow(1.-plcost[i+9][3],dyr);

      u=plcost[i+9][4];

      if(u==0.)      v*=rlcost[0][n][ky0];

      else if(u==1.) v*=rlcost[1][n][ky0];

      else if(u==2.) v*=rlcost[2][n][ky0];

      else if(u==3.) v*=rlcost[3][n][ky0];

      else if(u==4.) v*=rlcost[4][n][ky0];

      else if(u==5.) v*=rlcost[5][n][ky0];

      else if(u==6.) v*=rlcost[6][n][ky0];

      else if(u==7.) v*=rlcost[7][n][ky0];

      else if(u==8.) v*=rlcost[8][n][ky0];

      else if(u==9.) v*=rlcost[9][n][ky0];

      else {

        printf(" Please Check 'plcost[i][4]'.\n");

        exit(0);

      }

      mc[i+6][k]=plcost[i+9][1]*plcost[i+9][2]*v/365.;

    }

  }





  for(k=0;k<N_BLK;k++) {

    zdf=dis_f[n_tm[k]]*prob_k[k];

    ky0=n_tm[k];

    k1=inc_mat[0][k];

    k2=inc_mat[1][k];

    dyr=n_yr[ky0]-start_yr;



 /* Supplied Energy Prices */

    for(i=0;i<8;i++) txm[tc_price[0]][i][k]=sdm[ir[1][0][i][k]]/zdf;



 /* Marginal Production Costs of Renewable Energy Sources */



    for(i=0;i<N_REN-2;i++) {

      v=pow(1.-acrdrt[i][0],n_yr[0]-start_yr);

      for(j=1;j<=ky0;j++) v*=pow(1.-acrdrt[i][j],n_yr[j]-n_yr[j-1]);

      for(j=0;j<N_RGRADE+1;j++)

        rpck[n][i][j][k]=rpcost[n][i][j]*v;

      for(j=0;j<N_RGRADE;j++) {

        slope_f[n][i][j][k]

            =(rpck[n][i][j+1][k]+rpck[n][i][j][k])*rgdk[n][i][j]/2.;

        slope_df[n][i][j][k]

            =(rpck[n][i][j+1][k]-rpck[n][i][j][k])/rgdk[n][i][j];

      }

    }



    j0=tc_price[1];

    for(i=0;i<N_REN-2;i++) 

      txm[j0][i][k]=fprice(n,i,k,xm[jc[3][i][0][k]]);;

    v=pow(1.-acrdrt[2][0],n_yr[0]-start_yr);

    for(j=1;j<=ky0;j++) v*=pow(1.-acrdrt[2][j],n_yr[j]-n_yr[j-1]);

    txm[j0][N_REN-2][k]=rpcost[n][2][0]*v;

	v=pow(1.-acrdrt[3][0],n_yr[0]-start_yr);

    for(j=1;j<=ky0;j++) v*=pow(1.-acrdrt[3][j],n_yr[j]-n_yr[j-1]);

    for(i=0;i<24;i++) {

      if(xm[jc[3][3][i][k]]>0.001) u=bio_cost[n][i]*v;

      else u=1.e9;

      txm[tc_price[1]][i+3][k]=u;

    }



 /* Imported Prices */

    for(i=0;i<IINTER;i++) {

      if(xm[jc[0][i][n][k]]>0.001) u=p[i*LR+n+KEL*k];

      else u=1.e9;

      txm[tc_price[2]][i][k]=u;

    }

    for(i=0;i<ITRANS;i++) {

      if(xm[jc[1][i][1][k]]>0.001) u=p[IINTER*LR+i+KEL*k];

      else u=1.e9;

      txm[tc_price[2]][i+IINTER][k]=u;

    }



 /* Energy Prices in End-Use Sectors */

    for(i=0;i<N_DEM;i++) {

      j=jc[6][0][i][k];

      v=(rdemak[n][i][k]+xm[j])/cdemak[n][i][k];

      u=(shdpri[n][i][ky0]+dispri[n][i][ky0])*pow(v,prelas[n][i]);

      if(ictrl1==1 && xm[j]<0.001) u+=g[n][j]/zdf;

      txm[tc_price[3]][i][k]=u;

      txm[tc_price[4]][i][k]=u/enepri[n][i]*100.;

    }



 /* Marginal Costs in Electric Power Sector */



    txm[tc_price[5]][0][k]=sdm[ir[2][1][0][k]]/zdf;

    txm[tc_price[5]][1][k]=sdm[ir[2][1][1][k]]/zdf;

    txm[tc_price[5]][2][k]=sdm[ir[2][1][2][k]]/zdf;

    txm[tc_price[5]][3][k]=sdm[ir[2][1][3][k]]/zdf;



 /* Shadow Prices of Carbon */

    txm[tc_price[6]][0][k]=sdm[ir[1][0][6][k]]/zdf;



 /* Shadow Prices of Sulphur */

    txm[tc_price[7]][0][k]=sdm[ir[1][0][12][k]]/zdf;



 /**************  Cost Calculation *************************/



    ctax=0.;

    if(ictrl2==1) {

      i=0;

      while(n_sc[i][k]==0) {i++;}

      ctax=co2tax[n][i][ky0];

    }

    stax=0.;

    if(ictrl9==1) {

      i=0;

      while(n_sc[i][k]==0) {i++;}

      stax=sultax[n][i][ky0];

    }



 /* Transportation Cost */

    for(i=0;i<10;i++) {

      v=pow(1.-trcost[i][2],dyr);

      tc[i][0]=trcost[i][0]*v;

      tc[i][1]=trcost[i][1]*v;

    }



    for(i=0;i<IINTER;i++) {

      v=pow(1.-plcost[24+i][3],dyr)*plcost[24+i][1]

       *plcost[24+i][2]/plcost[24+i][0]/365.;

      tc[2*i][0]+=v;

    }

    tc[9][0]+=v; /* CO2 Ocean Disposal */



  /* Inter-regional Transportation */

    j0=tc_cost[0];

    for(j=0;j<IINTER;j++) {

      txm[j0][j][k]=0.;

      for(i=0;i<LR;i++) {

        if(i!=n) {

          v=tc[2*j][1]*trocea[n][i]+tc[2*j+1][1]*trland[n][i];

          if(trocea[n][i]!=0.) v+=tc[2*j][0];

          if(trland[n][i]!=0.) v+=tc[2*j+1][0];

          txm[j0][j][k]+=xm[jc[0][j][i][k]]*v;

	}

      }

    }

    for(i=0;i<3;i++)

      txm[j0][i+IINTER][k]=xm[jc[1][i][0][k]]*tc[6+i][0];

    txm[j0][IINTER][k]+=xm[jc[1][5][0][k]]*tc[6][0];

    v=0.;

    for(i=0;i<IINTER+3;i++) v+=txm[j0][i][k];

    txm[j0][IINTER+3][k]=v;

    id_cost[0]=IINTER+3;



  /* Inter-regional Trade Accounts */

    j0=tc_cost[1];

    for(j=0;j<IINTER;j++) {

      v=xm[jc[0][j][n][k]]*p[j*LR+n+KEL*k];

      for(i=0;i<LR;i++) {

        if(i!=n) v-=xm[jc[0][j][i][k]]*p[j*LR+i+KEL*k];

      }

      txm[j0][j][k]=v;

    }

    for(i=0;i<3;i++)

      txm[j0][i+IINTER][k]=(xm[jc[1][i][1][k]]-xm[jc[1][i][0][k]])

                           *p[IINTER*LR+i+KEL*k];

    txm[j0][IINTER][k]+=(xm[jc[1][5][1][k]]-xm[jc[1][5][0][k]])

                           *p[IINTER*LR+5+KEL*k];

    v=0.;

    for(i=0;i<IINTER+3;i++) v+=txm[j0][i][k];

    txm[j0][IINTER+3][k]=v;

    id_cost[1]=IINTER+3;



  /* Trade Profits */

    j0=tc_cost[2];

    for(j=0;j<IINTER-1;j++) {

      v=0.;

      for(i=0;i<LR;i++) 

        if(i!=n) v+=xm[jc[0][j][i][k]]*profit[n][j][ky0];

      txm[j0][j][k]=v;

    }

    for(i=0;i<3;i++)

      txm[j0][i+IINTER-1][k]=xm[jc[1][i][0][k]]*profit[n][IINTER-1+i][ky0];

    txm[j0][IINTER-1][k]+=xm[jc[1][5][0][k]]*profit[n][IINTER-1][ky0];

    v=0.;

    for(i=0;i<IINTER+2;i++) v+=txm[j0][i][k];

    txm[j0][IINTER+2][k]=v;

    id_cost[2]=IINTER+2;



  /* Trade Tariffs */

    j0=tc_cost[3];

    for(i=0;i<IINTER-1;i++) 

      txm[j0][i][k]=xm[jc[0][i][n][k]]*tariff[n][i][ky0];

    for(i=0;i<3;i++)

      txm[j0][i+IINTER-1][k]=xm[jc[1][i][1][k]]*tariff[n][IINTER-1+i][ky0];

    txm[j0][IINTER-1][k]+=xm[jc[1][5][1][k]]*tariff[n][IINTER-1][ky0];

    v=0.;

    for(i=0;i<IINTER+2;i++) v+=txm[j0][i][k];

    txm[j0][IINTER+2][k]=v;

    id_cost[3]=IINTER+2;



  /* Emission Rights Trade */

    j0=tc_cost[4];

    if(ictrl3==1) {

      txm[j0][0][k]

        =(xm[jc[1][3][1][k]]-xm[jc[1][3][0][k]])*p[LR*IINTER+3+KEL*k];

      txm[j0][1][k]=xm[jc[1][3][0][k]]*co2tran[n][0][ky0];

      txm[j0][2][k]

        =(xm[jc[1][4][1][k]]-xm[jc[1][4][0][k]])*p[LR*IINTER+4+KEL*k];

      txm[j0][3][k]=xm[jc[1][4][0][k]]*co2tran[n][1][ky0];

    }

    else {

      txm[j0][0][k]=0.;

      txm[j0][1][k]=0.;

      txm[j0][2][k]=0.;

      txm[j0][3][k]=0.;

    }

    txm[j0][4][k]=txm[j0][0][k]+txm[j0][1][k]+txm[j0][2][k]+txm[j0][3][k];

    id_cost[4]=4;



  /* Fossil Fuel Production Costs */

    j0=tc_cost[5];

    u=0.;

    for(i=0;i<N_FOS;i++) {

      v=0.;

      for(j=0;j<N_EGRADE;j++) v+=xm[jc[2][i][j][k]]*epcost[i][j];

      txm[j0][i][k]=v;

      u+=v;

    }

    txm[j0][N_FOS][k]=u;

    id_cost[5]=N_FOS;



  /* Royalties for Fossil Fuel Production */

    j0=tc_cost[6];

    u=0.;

    for(i=0;i<N_FOS;i++) {

      v=0.;

      for(j=0;j<N_EGRADE;j++) v+=xm[jc[2][i][j][k]]*royalt[n][i][ky0];

      txm[j0][i][k]=v;

      u+=v;

    }

    txm[j0][N_FOS][k]=u;

    id_cost[6]=N_FOS;



  /* Non-fossil Energy Production Costs */

    j0=tc_cost[7];

    for(i=0;i<N_REN-2;i++) txm[j0][i][k]=frcost(n,i,k,xm[jc[3][i][0][k]]);

    v=pow(1.-acrdrt[2][0],n_yr[0]-start_yr);

    for(j=1;j<=ky0;j++) v*=pow(1.-acrdrt[2][j],n_yr[j]-n_yr[j-1]);

    txm[j0][2][k]=xm[jc[3][2][0][k]]*rpcost[n][2][0]*v;

    v=pow(1.-acrdrt[3][0],n_yr[0]-start_yr);

    for(j=1;j<=ky0;j++) v*=pow(1.-acrdrt[3][j],n_yr[j]-n_yr[j-1]);

	u=0.;

	for(i=0;i<24;i++) u+=bio_cost[n][i]*v*xm[jc[3][3][i][k]];

    txm[j0][3][k]=u;

    txm[j0][4][k]=xm[jc[2][3][0][k]]*nclrct[ky0];

    v=0.;

    for(i=0;i<5;i++) v+=txm[j0][i][k];

    txm[j0][5][k]=v;

    id_cost[7]=5;



  /* Subsidies for Energy Production */

    j0=tc_cost[8];

    for(i=0;i<N_FOS;i++) {

      v=0.;

      for(j=0;j<N_EGRADE;j++) v-=xm[jc[2][i][j][k]]*subsid[n][i][ky0];

      txm[j0][i][k]=v;

    }

    for(i=0;i<N_REN;i++)

      txm[j0][N_FOS+i][k]=-xm[jc[3][i][0][k]]*subsid[n][i+N_FOS][ky0];

    v=0.;

    for(i=0;i<N_FOS;i++) v+=txm[j0][i][k];

    txm[j0][N_FOS+N_REN+1][k]=v;

    txm[j0][N_FOS+N_REN][k]=v;

    v=0.;

    for(i=N_FOS;i<N_FOS+N_REN;i++) v+=txm[j0][i][k];

    txm[j0][N_FOS+N_REN+2][k]=v;

    txm[j0][N_FOS+N_REN][k]+=v;

    id_cost[8]=N_FOS+N_REN;





/* Plant Construction Costs */

    j0=tc_cost[9];

    for(i=0;i<9;i++) {

      v=mc[i][k]*xm[jc[8][0][i][k]];

      if(k1!=-1&&k<6) v+=mc[i][k1]*xm[jc[8][0][i][k1]];

      if(k2!=-1&&k<6) v+=mc[i][k2]*xm[jc[8][0][i][k2]];

      txm[j0][i][k]=v;

    }

    for(i=0;i<15;i++) {

      v=mc[i+9][k]*xm[jc[8][1][i][k]];

      if(k1!=-1&&k<6) v+=mc[i+9][k1]*xm[jc[8][1][i][k1]];

      if(k2!=-1&&k<6) v+=mc[i+9][k2]*xm[jc[8][1][i][k2]];

      txm[j0][i+9][k]=v;

    }

	for(i=18;i<20;i++) {

      v=mc[i+6][k]*xm[jc[8][1][i-3][k]];

      if(k1!=-1&&k<6) v+=mc[i+6][k1]*xm[jc[8][1][i-3][k1]];

      if(k2!=-1&&k<6) v+=mc[i+6][k2]*xm[jc[8][1][i-3][k2]];

      txm[j0][i+6][k]=v;

    }

    if(ky0==0) {

      for(i=0;i<5;i++) {

        u=plcost[iep[i]][4];

        if(u==0.)      v=rlcost[0][n][0];

        else if(u==1.) v=rlcost[1][n][0];

        else if(u==2.) v=rlcost[2][n][0];

        else if(u==3.) v=rlcost[3][n][0];

        else if(u==4.) v=rlcost[4][n][0];

        else if(u==5.) v=rlcost[5][n][0];

        else if(u==6.) v=rlcost[6][n][0];

        else if(u==7.) v=rlcost[7][n][0];

        else if(u==8.) v=rlcost[8][n][0];

        else if(u==9.) v=rlcost[9][n][0];

        else {

          printf(" Please Check 'plcost[i][4]'.\n");

          exit(0);

        }

        txm[j0][iep[i]][k]

          +=plcost[iep[i]][1]*plcost[iep[i]][2]*v

            *(cexist[n][i][0]+cexist[n][i][1]);

      }

      for(i=0;i<2;i++) {

        u=plcost[9+i][4];

        if(u==0.)      v=rlcost[0][n][0];

        else if(u==1.) v=rlcost[1][n][0];

        else if(u==2.) v=rlcost[2][n][0];

        else if(u==3.) v=rlcost[3][n][0];

        else if(u==4.) v=rlcost[4][n][0];

        else if(u==5.) v=rlcost[5][n][0];

        else if(u==6.) v=rlcost[6][n][0];

        else if(u==7.) v=rlcost[7][n][0];

        else if(u==8.) v=rlcost[8][n][0];

        else if(u==9.) v=rlcost[9][n][0];

        else {

          printf(" Please Check 'plcost[i][4]'.\n");

          exit(0);

        }

        txm[j0][9+i][k]

          +=plcost[9+i][1]*plcost[9+i][2]*v/365.

            *(cexist[n][5+i][0]+cexist[n][5+i][1]);

      }

    }



    if(ky0==1) {

      for(i=0;i<5;i++) {

        u=plcost[iep[i]][4];

        if(u==0.)      v=rlcost[0][n][0];

        else if(u==1.) v=rlcost[1][n][0];

        else if(u==2.) v=rlcost[2][n][0];

        else if(u==3.) v=rlcost[3][n][0];

        else if(u==4.) v=rlcost[4][n][0];

        else if(u==5.) v=rlcost[5][n][0];

        else if(u==6.) v=rlcost[6][n][0];

        else if(u==7.) v=rlcost[7][n][0];

        else if(u==8.) v=rlcost[8][n][0];

        else if(u==9.) v=rlcost[9][n][0];

        else {

          printf(" Please Check 'plcost[i][4]'.\n");

          exit(0);

        }

        txm[j0][iep[i]][k]

          +=plcost[iep[i]][1]*plcost[iep[i]][2]*v*cexist[n][i][0];

      }

      for(i=0;i<2;i++) {

        u=plcost[9+i][4];

        if(u==0.)      v=rlcost[0][n][0];

        else if(u==1.) v=rlcost[1][n][0];

        else if(u==2.) v=rlcost[2][n][0];

        else if(u==3.) v=rlcost[3][n][0];

        else if(u==4.) v=rlcost[4][n][0];

        else if(u==5.) v=rlcost[5][n][0];

        else if(u==6.) v=rlcost[6][n][0];

        else if(u==7.) v=rlcost[7][n][0];

        else if(u==8.) v=rlcost[8][n][0];

        else if(u==9.) v=rlcost[9][n][0];

        else {

          printf(" Please Check 'plcost[i][4]'.\n");

          exit(0);

        }

        txm[j0][9+i][k]

          +=plcost[9+i][1]*plcost[9+i][2]*v/365.*cexist[n][5+i][0];

      }

    }



    v=0.;

    for(i=0;i<26;i++) v+=txm[j0][i][k];

    txm[j0][26][k]=v;

    id_cost[9]=26;



/* CO2 Disposal */

    j0=tc_cost[10];

    v=tc[5][1]*trnco2[n][0];

    if(trnco2[n][0]!=0.) v+=tc[5][0];

    txm[j0][0][k]=(v+co2cst[n][0])*xm[jc[2][4][0][k]]

                 +(v+co2cst[n][1])*xm[jc[2][4][1][k]];

    txm[j0][1][k]=(v+co2cst[n][2])*xm[jc[2][4][2][k]];

    u=0.;

    for(i=0;i<5;i++) u+=(v+co2cst[n][i+3])*xm[jc[2][4][i+3][k]];

    txm[j0][2][k]=u;

    v=tc[5][1]*trnco2[n][1]+tc[9][1]*trnco2[n][2];

    if(trnco2[n][1]!=0.) v+=tc[5][0];

    if(trnco2[n][2]!=0.) v+=tc[9][0];

    txm[j0][3][k]=(v+co2cst[n][N_DCO2-1])*xm[jc[2][4][N_DCO2-1][k]];

    v=0.;

    for(i=0;i<4;i++) v+=txm[j0][i][k];

    txm[j0][4][k]=v;

    id_cost[10]=4;



  /* Desulphur */

    j0=tc_cost[17];

    txm[j0][0][k]=xm[jc[7][4][0][k]]*desulc[0][1];

    txm[j0][1][k]=xm[jc[7][6][3][k]]*desulc[4][1];

    for(i=0;i<3;i++)

      txm[j0][i+2][k]=(xm[jc[7][4][i+1][k]]+xm[jc[7][6][i][k]])*desulc[0][i+1];

    txm[j0][5][k]=xm[jc[7][5][0][k]]*desuld[0]; 

    for(i=0;i<2;i++)

      txm[j0][5][k]+=(xm[jc[7][5][i+1][k]]+xm[jc[7][7][i][k]])*desuld[0];

    v=0.;

    for(i=0;i<6;i++) v+=txm[j0][i][k];

	txm[j0][6][k]=v;

    id_cost[17]=6;



  /* Energy Conservation and Macro Economy */

    j0=tc_cost[11];

    if(ictrl8==0) {

      for(i=0;i<N_DEM;i++) {

        j=jc[6][0][i][k];

        v=(rdemak[n][i][k]+xm[j])/cdemak[n][i][k];

        txm[j0][i][k]=cdemak[n][i][k]/(1.+prelas[n][i])

        *(shdpri[n][i][ky0]+dispri[n][i][ky0])*(1.-pow(v,prelas[n][i]+1.));

      }

      v=0.;

      for(i=0;i<N_DEM;i++) v+=txm[j0][i][k];

      txm[j0][N_DEM][k]=v;

      id_cost[11]=N_DEM;

    }

    else {

      txm[j0][0][k]=(xm[jc[6][3][0][k]]+rkap[n][k])*1000.;

      txm[j0][1][k]=xm[jc[6][3][1][k]]*1000.;

      sum_ec=0.;

      for(i=0;i<N_DEM;i++) {

        v=cdemak[n][i][k]*(shdpri[n][i][ky0]+dispri[n][i][ky0]);

        sum_ec+=v;

        prod_b[n][i][k]=v;

      }

      prod_c[n][k]=kap0[n][ky0]*(mepm[n][0]+discnt[ky0])

                           /(gdp0[n][ky0]-sum_ec)*klelas[n];

      v=pow(gdp0[n][ky0],klelas[n]-1.);

      prod_a[n][k]=(gdp0[n][ky0]-sum_ec)*v;

      for(i=0;i<N_DEM;i++)

        prod_b[n][i][k]*=pow(v*sum_ec,enelas[n]/klelas[n]-1.)*v;



      v=0.;

      for(i=0;i<N_DEM;i++) {

        u=(rdemak[n][i][k]+xm[jc[6][0][i][k]])/cdemak[n][i][k];

        v+=prod_b[n][i][k]*pow(u,enelas[n]);

      }

      v=pow(v,klelas[n]/enelas[n]);

      u=(xm[jc[6][3][0][k]]+rkap[n][k])/kapk[n][k];

      v+=prod_a[n][k]*pow(u,prod_c[n][k]);

      txm[j0][2][k]=pow(v,1./klelas[n]);

      txm[j0][3][k]=kap0[n][ky0];

      txm[j0][4][k]=inv0[n][ky0];

      txm[j0][5][k]=gdp0[n][ky0];

      txm[j0][6][k]=gdp0[n][ky0]-inv0[n][ky0]+txm[j0][1][k]-txm[j0][2][k];

      id_cost[11]=6;

    }





  /* Energy Distribution Costs */

    j0=tc_cost[12];

    for(i=0;i<N_DEM;i++) 

      txm[j0][i][k]

       =(xm[jc[6][0][i][k]]+rdemak[n][i][k]-cdemak[n][i][k])*dispri[n][i][ky0];

    v=0.;

    for(i=0;i<N_DEM;i++) v+=txm[j0][i][k];

    txm[j0][N_DEM][k]=v;

    id_cost[12]=N_DEM;



  /* Summary */

    j0=tc_cost[13];

    v=0.;

    for(i=0;i<4;i++) v+=txm[tc_cost[i]][id_cost[i]][k];

    txm[j0][0][k]=v;

    txm[j0][1][k]=txm[tc_cost[4]][id_cost[4]][k];

    txm[j0][2][k]=txm[tc_cost[5]][id_cost[5]][k]

                 +txm[tc_cost[6]][id_cost[6]][k]

                 +txm[tc_cost[8]][id_cost[8]+1][k];

    txm[j0][3][k]=txm[tc_cost[7]][id_cost[7]][k]

                 +txm[tc_cost[8]][id_cost[8]+2][k];

    txm[j0][4][k]=txm[tc_cost[9]][id_cost[9]][k];

    txm[j0][5][k]=txm[tc_cost[10]][id_cost[10]][k];

    txm[j0][6][k]=txm[tc_cost[17]][id_cost[17]][k];

    txm[j0][7][k]=txm[tc_cost[11]][id_cost[11]][k]

                 +txm[tc_cost[12]][id_cost[12]][k];

    v=0;

    for(i=0;i<N_REFO;i++)

      v+=refore[n][5+i]*txm[ta_eco2][9+i][k];

    txm[j0][8][k]=v;



    txm[j0][9][k]=ctax*txm[ta_eco2][7][k];

    txm[j0][10][k]=stax*xm[jc[6][4][0][k]];



/* Innovative New-Technologies */

    v=txm[j0][0][k];;

    for(i=2;i<7;i++) v+=txm[j0][i][k];

    txm[j0][11][k]=v*sh_new_t[n][ky0]/(1.-sh_new_t[n][ky0]);



/* Total */

    v=0.;

    for(i=0;i<12;i++) v+=txm[j0][i][k];

    txm[j0][12][k]=v;

    id_cost[13]=12;

    for(i=0;i<14;i++)

      for(j=0;j<30;j++) txm[tc_cost[i]][j][k]/=1000.;

    for(j=0;j<30;j++) txm[tc_cost[17]][j][k]/=1000.;



/* Damage due to Climate Change */

    if(ictrl7==0)

      txm[j0][13][k]=0.;

    else {

      txm[j0][13][k]=gdp0[n][ky0]*mepm[n][4]*1.e-5

        *pow(xm[jc[6][2][0][k]]/2.5*1.e-5,mepm[n][5]);

    }

/* Reference GDP */

    txm[j0][14][k]=gdp0[n][ky0]/1000.;

  }



/* Discounted Total Cost */

  j0=tc_cost[13];

  for(k=0;k<N_SCE;k++) {

    for(i=0;i<15;i++) {

      v=0.;

      for(j=0;j<N_TMP;j++) v+=txm[j0][i][isce[k][j]]*dis_f[j];

      txm[tc_cost[14]][i][k]=v;

    }

  }



}





  void account_m()

{ int i,j,k,ky0,n;

  double u,v,agr,***z,***w,tt1,tt2,uu[3],vv[3],ww[3];



  z=m_darr3(LR+6,5,N_BLK+1);

  w=m_darr3(LR+6,5,N_BLK+1);



  for(n=0;n<LR;n++) {

     v=0.;

     u=0.;

     for(i=0;i<N_FOS;i++) {

       v+=ele_2000[n][i];

       u+=ele_2000[n][i]/(ect_2000[i+1]*rel_2000[i][n]);

     }

     agr=u/v/etcon;

  /* Final Energy Demand */

     v=dem_2000[n][N_DEM-1]/etcon;

     for(i=0;i<N_DEM-1;i++) v+=dem_2000[n][i];

     z[n][0][0]=v;



  /* Secondary Energy Consumption */

     z[n][1][0]=z[n][0][0];

 

  /* Primary Energy Consumption */

     v=currpr[n][3]+(currpr[n][4]+currpr[n][5]+ele_2000[n][3])*agr;

     for(i=0;i<N_FOS;i++) v+=prtrad[n][i]+currpr[n][i];

     z[n][2][0]=v;

     

  /* Gross CO2 Emissions */

     z[n][3][0]=cem_2000[n];



  /* Net CO2 Emissions */

     z[n][4][0]=z[n][3][0];

   }



  for(k=0;k<N_BLK;k++) {

     ky0=n_tm[k];

     for(n=0;n<LR;n++) {



  /* Final Energy Demand */

       v=demand[n][N_DEM-1][ky0]/etcon;

       for(i=0;i<N_DEM-1;i++)

         v+=demand[n][i][ky0]*(1.-shfdsk[n][i]);

       v*=(1.-sh_new_t[n][k]);

       for(i=0;i<N_DEM-1;i++)

         v+=demand[n][i][ky0]*shfdsk[n][i];

       z[n][0][k+1]=v;



  /* Secondary Energy Consumption */

       v=0.;

       for(i=0;i<8;i++) v+=tx[n][ts_sene][i][k];

       z[n][1][k+1]=v;

  /* Primary Energy Consumption */

       v=0.;

       for(i=0;i<9;i++) v+=tx[n][ts_psup][i][k];

       z[n][2][k+1]=v;

     

  /* Gross CO2 Emissions */

       z[n][3][k+1]=tx[n][ta_eco2][0][k];



  /* Net CO2 Emissions */

       z[n][4][k+1]=tx[n][ta_eco2][7][k];

     }

   }

  for(k=0;k<N_BLK+1;k++)

    for(i=0;i<5;i++) {

      v=0.;

      for(n=0;n<LR;n++) v+=z[n][i][k];

      z[LR][i][k]=v;

      v=0.;

      for(n=0;n<4;n++) v+=z[n][i][k];

      z[LR+1][i][k]=v;

      v=0.;

      for(n=4;n<LR;n++) v+=z[n][i][k];

      z[LR+2][i][k]=v;

      v=z[9][i][k];

      for(n=0;n<4;n++) v+=z[n][i][k];

      z[LR+3][i][k]=v;

      v=0.;

      for(n=4;n<9;n++) v+=z[n][i][k];

      z[LR+4][i][k]=v;

      v=0.;

      for(n=4;n<6;n++) v+=z[n][i][k];

      z[LR+5][i][k]=v;

    }



  v=0.;

  for(n=0;n<LR;n++) v+=cem_2000[n];

  cem_2000[LR]=v;

  v=0.;

  for(n=0;n<4;n++) v+=cem_2000[n];

  cem_2000[LR+1]=v;

  v=0.;

  for(n=4;n<LR;n++) v+=cem_2000[n];

  cem_2000[LR+2]=v;

    v=cem_2000[9];

  for(n=0;n<4;n++) v+=cem_2000[n];

  cem_2000[LR+3]=v;

  v=0.;

  for(n=4;n<9;n++) v+=cem_2000[n];

  cem_2000[LR+4]=v;

  v=0.;

  for(n=4;n<6;n++) v+=cem_2000[n];

  cem_2000[LR+5]=v;



  for(n=0;n<LR+6;n++)

    for(i=0;i<3;i++) w[n][i][0]=0.;



  for(k=1;k<N_BLK+1;k++) 

    for(n=0;n<LR+6;n++) {

      tx[n][ts_cont][0][k-1]=z[n][3][0]/z[n][0][0]*(z[n][0][k]-z[n][0][0]);

      tx[n][ts_cont][4][k-1]=z[n][4][k]-z[n][3][k];

      tx[n][ts_cont][5][k-1]=z[n][4][k];



      for(i=0;i<3;i++) {

        uu[i]=z[n][i+1][k-1]/z[n][i][k-1];

        vv[i]=z[n][i+1][k]/z[n][i][k];

        ww[i]=vv[i]-uu[i];

      }

      tt1=uu[1]*uu[2]+ww[1]*ww[2]/3.;

      tt2=(uu[1]*ww[2]+ww[1]*uu[2])/2.;

      w[n][0][k]=(tt1+tt2)*ww[0];

      tt1=uu[0]*uu[2]+ww[0]*ww[2]/3.;

      tt2=(uu[0]*ww[2]+ww[0]*uu[2])/2.;

      w[n][1][k]=(tt1+tt2)*ww[1];

      tt1=uu[0]*uu[1]+ww[0]*ww[1]/3.;

      tt2=(uu[0]*ww[1]+ww[0]*uu[1])/2.;

      w[n][2][k]=(tt1+tt2)*ww[2];

    }



  for(k=1;k<N_BLK+1;k++) 

    for(n=0;n<LR+6;n++)

      for(i=0;i<3;i++) {

        v=w[n][i][k];

        for(j=0;j<k;j++) v+=w[n][i][inc_mat[0][j]+1];

        tx[n][ts_cont][i+1][k-1]=v*z[n][0][k];

      }

}





  double fslope(n,i,j,k,q,q0)

  int n,i,k,*j;

  double q,*q0;

{ double slope,q1;

  *q0=0.;

  q1=rgdk[n][i][0];

  *j=0;

  while(q1<q && *j<4) {

    ++(*j);

    *q0=q1;

    q1+=rgdk[n][i][*j];

  }

  if(*j<4) slope=slope_df[n][i][*j][k];

  else     slope=slope_df[n][i][4][k];

  return(slope);

}







  double frcost(n,i,k,q)

  int n,i,k;

  double q;

{ double q0,cost,slope,dq;

  int j0,j;

  slope=fslope(n,i,&j0,k,q,&q0);

  cost=0.;

  for(j=0;j<j0;j++) cost+=slope_f[n][i][j][k];

  dq=q-q0;

  cost+=dq*(0.5*slope*dq+rpck[n][i][j0][k]);

  return(cost);

}





  double fprice(n,i,k,q)

  int n,i,k;

  double q;

{ double q0,slope,price;

  int j;

  slope=fslope(n,i,&j,k,q,&q0);

  price=rpck[n][i][j][k]+slope*(q-q0);

  return(price);

}







